
from reportlab.platypus import *
from reportlab import rl_config
from reportlab.lib.styles import PropertySet, getSampleStyleSheet, ParagraphStyle
from reportlab.lib import colors
from reportlab.lib.utils import fp_str
from reportlab.pdfbase import pdfmetrics
import operator, string

from types import TupleType, ListType, StringType

import pyfribidi

import tables

class CellStyle1(PropertySet):
    fontname = "Times-Roman"
    fontsize = 10
    leading = 12
    leftPadding = 6
    rightPadding = 6
    topPadding = 3
    bottomPadding = 3
    firstLineIndent = 0
    color = colors.black
    alignment = 'RIGHT'
    background = (1,1,1)
    valign = "BOTTOM"
    def __init__(self, name, parent=None):
        self.name = name
        if parent is not None:
            parent.copy(self)
    def copy(self, result=None):
        if result is None:
            result = CellStyle1()
        for name in dir(self):
            setattr(result, name, gettattr(self, name))
        return result

class TableRTL(tables.Table):
    defaultCellStyle = CellStyle1
    def _calc_width(self):
        tables.Table._calc_width(self)
        self._colpositions = [ self._width - w for w in self._colpositions]
        

    def _drawCell(self, cellval, cellstyle, (colpos, rowpos), (colwidth, rowheight)):
        tables.Table._drawCell(self, cellval, cellstyle, (colpos-colwidth, rowpos), (colwidth, rowheight))

    def drawString(self, x, y, v):
        v = pyfribidi.log2vis(str(v), 1)
        self.canv.drawString(x, y, v)
    def drawCentredString(self, x, y, v):
        v = pyfribidi.log2vis(str(v), 1)
        self.canv.drawCentredString(x, y, v)
    def drawRightString(self, x, y, v):
        v = pyfribidi.log2vis(str(v), 1)
        self.canv.drawRightString(x, y, v)

